function varargout = aula_piv(varargin)
% AULA_PIV Application M-file for aula_piv.fig
%    FIG = AULA_PIV launch aula_piv GUI.
%    AULA_PIV('callback_name', ...) invoke the named callback.

% Last Modified by GUIDE v2.5 04-Dec-2012 14:59:47

if nargin == 0  % LAUNCH GUI

	fig = openfig(mfilename,'reuse');

	% Use system color scheme for figure:
	set(fig,'Color',get(0,'defaultUicontrolBackgroundColor'));
    

	% Generate a structure of handles to pass to callbacks, and store it. 
	handles = guihandles(fig);
	guidata(fig, handles);

	% Wait for callbacks to run and window to be dismissed:
    set(fig,'MenuBar','figure','Toolbar','figure');
	uiwait(fig);
    
    
	if nargout > 0
		varargout{1} = fig;
	end

elseif ischar(varargin{1}) % INVOKE NAMED SUBFUNCTION OR CALLBACK

	try
		if (nargout)
			[varargout{1:nargout}] = feval(varargin{:}); % FEVAL switchyard
		else
			 func_opt=lower(varargin{1});
            
            if strcmp(func_opt,'listbox1_callback')==1
                feval(varargin{:}); % FEVAL switchyard
            elseif strcmp(func_opt,'norm_img_callback')==1
                feval(varargin{:}); % FEVAL switchyard
            elseif strcmp(func_opt,'build_mask_callback')==1
                feval(varargin{:}); % FEVAL switchyard                
            elseif strcmp(func_opt,'intwin_callback')==1
                inter_win=feval(varargin{:}); % FEVAL switchyard
            elseif strcmp(func_opt,'end_win_callback')==1
                feval(varargin{:}); % FEVAL switchyard
            elseif strcmp(func_opt,'piv_run_callback')==1
                feval(varargin{:}); % FEVAL switchyard
            elseif strcmp(func_opt,'s_pass_callback')==1
                feval(varargin{:}); % FEVAL switchyard
            elseif strcmp(func_opt,'s_hart_callback')==1
                feval(varargin{:}); % FEVAL switchyard
            elseif strcmp(func_opt,'m_pass_callback')==1
                feval(varargin{:}); % FEVAL switchyard
            elseif strcmp(func_opt,'loadf_callback')==1
                feval(varargin{:}); % FEVAL switchyard
            elseif strcmp(func_opt,'gray_norm_callback')==1
                feval(varargin{:}); % FEVAL switchyard
            end
        end
   	catch
		disp(lasterr);
	end

end


%| ABOUT CALLBACKS:
%| GUIDE automatically appends subfunction prototypes to this file, and 
%| sets objects' callback properties to call them through the FEVAL 
%| switchyard above. This comment describes that mechanism.
%|
%| Each callback subfunction declaration has the following form:
%| <SUBFUNCTION_NAME>(H, EVENTDATA, HANDLES, VARARGIN)
%|
%| The subfunction name is composed using the object's Tag and the 
%| callback type separated by '_', e.g. 'slider2_Callback',
%| 'figure1_CloseRequestFcn', 'axis1_ButtondownFcn'.
%|
%| H is the callback object's handle (obtained using GCBO).
%|
%| EVENTDATA is empty, but reserved for future use.
%|
%| HANDLES is a structure containing handles of components in GUI using
%| tags as fieldnames, e.g. handles.figure1, handles.slider2. This
%| structure is created at GUI startup using GUIHANDLES and stored in
%| the figure's application data using GUIDATA. A copy of the structure
%| is passed to each callback.  You can store additional information in
%| this structure at GUI startup, and you can change the structure
%| during callbacks.  Call guidata(h, handles) after changing your
%| copy to replace the stored original so that subsequent callbacks see
%| the updates. Type "help guihandles" and "help guidata" for more
%| information.
%|
%| VARARGIN contains any extra arguments you have passed to the
%| callback. Specify the extra arguments by editing the callback
%| property in the inspector. By default, GUIDE sets the property to:
%| <MFILENAME>('<SUBFUNCTION_NAME>', gcbo, [], guidata(gcbo))
%| Add any extra arguments after the last argument, before the final
%| closing parenthesis.



% --------------------------------------------------------------------
function varargout = s_pass_Callback(h, eventdata, handles, varargin)
option_win='simple_pass';
set(handles.m_pass,'Value',0,'Enable','off');
set(handles.s_hart,'Value',0,'Enable','off');
set(handles.end_win,'Enable','off');
handles.optionwin=option_win;
guidata(gcbo,handles);

% --------------------------------------------------------------------
function varargout = s_hart_Callback(h, eventdata, handles, varargin)
option_win='simple_pass';
 set(handles.end_win,'Enable','off');    
 set(handles.m_pass,'Value',0,'Enable','off');
 set(handles.s_hart,'Value',0,'Enable','off');
 set(handles.s_pass,'Value',1);
 handles.optionwin=option_win;
 guidata(gcbo,handles);


%option_win='hart_single';
%set(handles.m_pass,'Value',0);
%set(handles.s_pass,'Value',0);
%set(handles.end_win,'Enable','off');
%handles.optionwin=option_win;
%guidata(gcbo,handles);

% --------------------------------------------------------------------
function varargout = m_pass_Callback(h, eventdata, handles, varargin)
 option_win='simple_pass';
 set(handles.end_win,'Enable','off');    
 set(handles.m_pass,'Value',0,'Enable','off');
 set(handles.s_hart,'Value',0,'Enable','off');
 set(handles.s_pass,'Value',1);
 handles.optionwin=option_win;
 guidata(gcbo,handles);


%option_win='multi_pass';
%set(handles.s_hart,'Value',0);
%set(handles.s_pass,'Value',0);
%set(handles.end_win,'Enable','on');
%handles.optionwin=option_win;
%guidata(gcbo,handles);



% --------------------------------------------------------------------
function varargout = load_mask_Callback(h, eventdata, handles, varargin)




% --------------------------------------------------------------------
function varargout = build_mask_Callback(h, eventdata, handles, varargin)




% --------------------------------------------------------------------
function [u,v,x,y,displ_x,displ_y,frame1,frame2] = piv_run_Callback(h, eventdata, handles, varargin)
old=pwd;
files=get(handles.listbox1,'string');
filetype=files(1,end-2:end);
tic
for iloop=1:2:length(files(:,1));
    hold off
    cd(handles.where);
    set(handles.listbox1,'Value',iloop);
    frame1=imread(files(iloop,:),'tiff');
    frame2=imread(files(iloop+1,:),'tiff');
    %frame1=imread(files(iloop,:),filetype);
    %frame2=imread(files(iloop+1,:),filetype);
    cd(old);
    %get(handles.gray_norm,'Value');
    if get(handles.gray_norm,'Value')==1
        %if exist('handles.initwin')==0
        %    if (length(frame1(:,:))>16)==1
        %        inter_win=16;
        %    else
        %        inter_win=length(frame1(:,:));
        %    end
        %else
        inter_win=handles.initwin;
        %end
        level_thres=get(handles.slider1,'Value');
        [frame1,frame2]=graynorm(frame1,frame2,inter_win,level_thres);
        imwrite(frame1/256,['proc-' files(iloop,:)],filetype);
        imwrite(frame2/256,['proc-' files(iloop+1,:)],filetype);
    end
    %if strcmp(handles.optionwin,'multi_pass')==1
    %    disp('multi_pass')
    %    [u,v,x,y,displ_x,displ_y,frame1,frame2]= piv(frame1,frame2,1,1,1,handles.initwin,handles.optionwin,handles.finalwin);
    %elseif strcmp(handles.optionwin,'hart_single')==1
    %    disp('single_hart')
    %    [u,v,x,y,displ_x,displ_y,frame1,frame2]= piv(frame1,frame2,1,1,1,handles.initwin,handles.optionwin,handles.initwin);
    %else
        handles.optionwin='simple_pass';
        disp('single_pass');
        [u,v,x,y,displ_x,displ_y]= piv(frame1,frame2,1,1,1,handles.initwin,handles.optionwin,handles.initwin);
    %end
    warning off
    invalid_u=isnan(u);
    invalid_v=isnan(u);
    u_tmp=u;
    u_tmp(invalid_u)=0;
    v_tmp=v;
    v_tmp(invalid_v)=0;
    %xlswrite('u.xls',u,[files(iloop,1:5) num2str(iloop)]);
    %xlswrite('v.xls',v,[files(iloop,1:5) num2str(iloop)]);
    %xlswrite('x.xls',x,[files(iloop,1:5) num2str(iloop)]);
    %xlswrite('y.xls',y,[files(iloop,1:5) num2str(iloop)]);
    if iloop<=5
        format_dat='';
        for i=1:length(x(1,:))-1
            format_dat=[format_dat '%.4f\t '];
        end
        format_dat=[format_dat '%.4f\n '];
        fname_x=[num2str(floor(iloop/2)+1) '_x.txt'];
        fname_y=[num2str(floor(iloop/2)+1) '_y.txt'];
        fname_u=[num2str(floor(iloop/2)+1) '_u.txt'];
        fname_v=[num2str(floor(iloop/2)+1) '_v.txt'];
        fid_x=fopen(fname_x,'w');
        fid_y=fopen(fname_y,'w');
        fid_u=fopen(fname_u,'w');
        fid_v=fopen(fname_v,'w');
        fprintf(fid_x,format_dat,x');
        fprintf(fid_y,format_dat,y');
        fprintf(fid_u,format_dat,u_tmp');
        fprintf(fid_v,format_dat,v_tmp');
        fclose(fid_x);
        fclose(fid_y);
        fclose(fid_u);
        fclose(fid_v);
    else
        fname_u=[num2str(floor(iloop/2)+1) '_u.txt'];
        fname_v=[num2str(floor(iloop/2)+1) '_v.txt'];
        fid_u=fopen(fname_u,'w');
        fid_v=fopen(fname_v,'w');
        fprintf(fid_u,format_dat,u_tmp');
        fprintf(fid_v,format_dat,v_tmp');
        fclose(fid_u);
        fclose(fid_v);
    end
    
    warning on;
    figure(gcbf);
    imagesc(frame1);
    colormap('gray')
    hold on;
    quiver(y,x,v,u,'-g');
    clear format_f
end
toc
disp('Processed...')
cd(old);


% --------------------------------------------------------------------
function varargout = listbox1_Callback(h, eventdata, handles, varargin)
position=get(handles.listbox1,'Value');
files=get(handles.listbox1,'string');
old=pwd;
cd(handles.where);
filetype=files(position,end-2:end);
frame1=imread(files(position,:),'tiff');
%frame1=imread(files(position,:),filetype);
cd(old)
if get(handles.gray_norm,'Value')==1
    if exist('handles.initwin')==0
        if (length(frame1(:,:))>16)==1
            inter_win=16;
        else
            inter_win=length(frame1(:,:));
        end
    else
        inter_win=handles.initwin;
    end
    level_thres=get(handles.slider1,'Value');
    [frame1,frame1]=graynorm(frame1,frame1,inter_win,level_thres);
end
imagesc(frame1);
colormap('gray');
set(gca,'xlim',[1 length(frame1(:,1))],'ylim',[1 length(frame1(:,1))]);




% --------------------------------------------------------------------
function varargout = loadf_Callback(h, eventdata, handles, varargin)
set(handles.listbox1,'String','');
[what1,where]=uigetfile('*.tif;*.bmp','Select the folder to process');
handles.where=where;
old=pwd;
cd(where);
filetype=what1(end-2:end);
files=ls(['*.' filetype]);
%files=ls('*.tif');
cd(old);
set(handles.listbox1,'String',files);

position=get(handles.listbox1,'Value');
files=get(handles.listbox1,'string');
old=pwd;
cd(handles.where);
filetype=files(position,end-2:end);
frame1=imread(files(position,:),'tiff');
%frame1=imread(files(position,:),filetype);
cd(old)
if get(handles.gray_norm,'Value')==1
    if exist('handles.initwin')==0
        inter_win=length(frame1(:,:));
    else
        inter_win=handles.initwin;
    end
    level_thres=get(handles.slider1,'Value');
    [frame1,frame1]=graynorm(frame1,frame1,inter_win,level_thres);
end
imagesc(frame1);
colormap('gray');
set(gca,'xlim',[1 length(frame1(:,1))],'ylim',[1 length(frame1(:,1))]);


guidata(gcbo,handles)



% --------------------------------------------------------------------
function varargout = intwin_Callback(h, eventdata, handles, varargin)
inter_win=2^(nextpow2(str2double(get(handles.intwin,'String'))));
varargout=cell(1);
handles.initwin=inter_win;
guidata(gcbo,handles)



% --------------------------------------------------------------------
function varargout = end_win_Callback(h, eventdata, handles, varargin)
inter_win_end=2^(nextpow2(str2double(get(handles.end_win,'String'))))
handles.finalwin=inter_win_end;
varargout=cell(1);
guidata(gcbo,handles);
disp(['Win init=' num2str(handles.initwin) ', final size=' num2str(handles.finalwin)])


% --- Executes on slider movement.
function varargout = slider1_Callback(h, eventdata, handles, varargin)
% hObject    handle to slider1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'Value') returns position of slider
%        get(hObject,'Min') and get(hObject,'Max') to determine range of slider


% --- Executes during object creation, after setting all properties.
%function slider1_CreateFcn(hObject, eventdata, handles)
% hObject    handle to slider1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called
% Hint: slider controls usually have a light gray background.
%if isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
%    set(hObject,'BackgroundColor',[.9 .9 .9]);
    
%end


% --- Executes on button press in gray_norm.
function varargout = gray_norm_Callback(hObject, eventdata, handles, varargin)
% hObject    handle to gray_norm (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
set(handles.slider1,'Min',0)
set(handles.slider1,'Value',0)
set(handles.slider1,'SliderStep',[0.005, 0.1])
set(handles.slider1,'Max',1)
if get(handles.gray_norm,'Value')==0
    set(handles.slider1,'Visible','off');
    set(handles.text1,'Visible','off');
else
    set(handles.slider1,'Visible','on');
    set(handles.text1,'Visible','on');
end
% Hint: get(hObject,'Value') returns toggle state of gray_norm
