function [c_hor,c_ver] = fitwhittaker2d(m,tol)
% function to perform a 2D whittaker fit
%% m = image
%tol = fitting tolerance

point=size(m); % size of the matrix
center_line=floor(point(1)/2)+1; %central line of the matrix
center_column=floor(point(2)/2)+1; %central line of the matrix

vert_dat=m(center_line,1:point(2)); %data used to find vertical position of the peak
hor_dat=m(1:point(1),center_column); % data used to find horizontal peak position

%[c_ver]=fitwhittaker(vert_dat,tol)
%[c_hor]=fitwhittaker(hor_dat,tol)

[c_ver]=shannon_w(vert_dat)
[c_hor]=shannon_w(hor_dat')


%figure
%contour(m,10);
%hold on
%plot(c_ver,c_hor,'xk')
return

function [center] = fitwhittaker(dat,tol)
% whittaker 
l_dat=length(dat);
central_p=floor(l_dat/2)+1;
t=central_p-1:tol:central_p+1;
l_t=length(t);

v(1:l_dat,1:l_t)=0; % pre-allocate memory
for j=1:l_dat
    v(j,:)=dat(j)*sinc(t(:)-j);
end

v_m=sum(v);

[max_val,center]=max(v_m);
center=center*tol+central_p-1; % transforming it to pixel


% Rotina Jos Firmino - Aula PIV 2012
function [dx]=shannon_w(vetorX)

N=length(vetorX);
t=(1:N)'; % Column vector of time samples
%randn('state',0);
xi=vetorX(1:N);% dados nao normalizados
x=xi';%vtor normalizado
NS=1000;%define a precisao N_S de interpolacao
Ds=linspace(-5,N+5,NS)'; %vezes de interpolao
S_x=Ds(:,ones(size(t)))-t(:,ones(size(Ds)))';%matrix com vetor S-x
%gera o vetor y
y=sinc(S_x)*x;
%somatorio da funcao Whittaker-Shannon com produto escalar
%figure
[lix,px]=max(y);
%dx=(px-NS/2)*N/NS;
dx=Ds(px);
%plot(t,x,'o',Ds,y,'-b',dx,lix,'sk');
