function [x_sav,y_sav,u_sav,v_sav,umed,vmed]= readdat_piv
%************************************************************
% Function to read saved data from piv program
% the vector field of each image pair is stored
% into the matrixs u_sav(:,:,i),v_sav(:,:,i) and their corresponding
% positions in the image coordinates are stored in x_sav and y_sav.

[status,nsheets]=xlsfinfo('x.xls');
for i=4:length(nsheets)% it always start to save data at the 4th sheet
    disp(['reading the worksheet n=' num2str(i)]);
    x_sav(:,:,i-3)=xlsread('x.xls',i);
    y_sav(:,:,i-3)=xlsread('y.xls',i);
    u_sav(:,:,i-3)=xlsread('u.xls',i);
    v_sav(:,:,i-3)=xlsread('v.xls',i);
end

% to calculate the mean vectors
npoints=size(x_sav);
 for i=1:npoints(1)
     for j=1:npoints(2)
         vec1=find(~isnan(squeeze(u_sav(i,j,:))));
         umed(i,j)=mean(nonzeros(squeeze(u_sav(i,j,vec1))));
         u_sav(i,j,find(isnan(squeeze(u_sav(i,j,:)))))=0;
         vec2=find(~isnan(squeeze(v_sav(i,j,:))));
         vmed(i,j)=mean(nonzeros(squeeze(v_sav(i,j,vec2))));
         v_sav(i,j,find(isnan(squeeze(v_sav(i,j,:)))))=0;
     end
 end
 figure
 quiver(y_sav(:,:,2),x_sav(:,:,2),v_sav(:,:,2),u_sav(:,:,2),4);
 set(gca,'ydir','reverse'); % refercia de 0 na imagem  o ponto mais ao alto a esquerda!!
return