function [x_sav,y_sav,u_sav,v_sav,umed,vmed]= readdat_piv2
%************************************************************
% Function to read saved data from piv program
% the vector field of each image pair is stored
% into the matrixs u_sav(:,:,i),v_sav(:,:,i) and their corresponding
% positions in the image coordinates are stored in x_sav and y_sav.

[what1,where]=uigetfile('*.txt','Select the folder to process');
%handles.where=where;
old=pwd;
cd(where);
files=ls('*.txt');
%files=ls('*.tif');

for i=1:length(files(:,1))/4% %number of txt files
    disp(['reading files n=' num2str(i)]);
    u_sav(:,:,i)=load(files((i-1)*4+1,:));
    v_sav(:,:,i)=load(files((i-1)*4+2,:));
    x_sav(:,:,i)=load(files((i-1)*4+3,:));
    y_sav(:,:,i)=load(files((i-1)*4+4,:));
end

% to calculate the mean vectors
npoints=size(x_sav);
 for i=1:npoints(1)
     for j=1:npoints(2)
         vec1=find(~isnan(squeeze(u_sav(i,j,:))));
         umed(i,j)=mean(nonzeros(squeeze(u_sav(i,j,vec1))));
         u_sav(i,j,find(isnan(squeeze(u_sav(i,j,:)))))=0;
         vec2=find(~isnan(squeeze(v_sav(i,j,:))));
         vmed(i,j)=mean(nonzeros(squeeze(v_sav(i,j,vec2))));
         v_sav(i,j,find(isnan(squeeze(v_sav(i,j,:)))))=0;
     end
 end
 cd(old);
 figure
 quiver(y_sav(:,:,1),x_sav(:,:,1),v_sav(:,:,1),u_sav(:,:,1),4);
 set(gca,'ydir','reverse'); % refercia de 0 na imagem  o ponto mais ao alto a esquerda!!
return